diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index dc13efe..8f3bde1 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -2390,11 +1827,11 @@ grouping_planner(PlannerInfo *root, bool inheritance_update,
 										parse->canSetTag,
 										parse->resultRelation,
 										rootRelation,
-										false,
-										list_make1_int(parse->resultRelation),
+										root->partColsUpdated,
+										resultRelations,
 										list_make1(path),
 										list_make1(root),
-										list_make1(root->update_tlist),
+										updateTargetLists,
 										withCheckOptionLists,
 										returningLists,
 										rowMarks,
@@ -7776,3 +7213,60 @@ group_by_has_partkey(RelOptInfo *input_rel,
 
 	return true;
 }
+
+/*
+ * is_result_relation
+ * 		Is passed-in relation a result relation of this query?
+ *
+ * While root->parse->resultRelation gives the query's original target
+ * relation, other target relations resulting from adding inheritance child
+ * relations of the main target relation are tracked elsewhere.
+ */
+bool
+is_result_relation(Index relid, PlannerInfo *root)
+{
+	InheritResultRelInfo *resultInfo;
+
+	if (relid == root->parse->resultRelation)
+		return true;
+
+	/*
+	 * There can be only one result relation in a given subquery before
+	 * inheritance child relation are added.
+	 */
+	if (root->inherit_result_rel_array == NULL)
+		return false;
+
+	resultInfo = root->inherit_result_rel_array[relid];
+	if (resultInfo == NULL)
+		return false;
+
+	return (relid == resultInfo->resultRelation);
+}
+
+/*
+ * get_result_update_tlist
+ *		Returns update targetlist of a given result relation
+ *
+ * Update targetlist for the main target relation is present in
+ * root->update_tlist, however that of inheritance child result relations is
+ * tracked elsewhere.
+ *
+ * Note: Don't call for a relation that is certainly not a result relation!
+ */
+List *
+get_result_update_tlist(PlannerInfo *root, Index result_relation)
+{
+	InheritResultRelInfo *resultInfo;
+
+	Assert(is_result_relation(result_relation, root));
+
+	if (result_relation == root->parse->resultRelation)
+		return root->update_tlist;
+
+	Assert(root->inherit_result_rel_array != NULL);
+	resultInfo = root->inherit_result_rel_array[result_relation];
+	Assert(resultInfo != NULL);
+
+	return resultInfo->update_tlist;
+}
diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index 4e439be..b900b23 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -273,6 +273,7 @@ set_plan_references(PlannerInfo *root, Plan *plan)
 		 * Neither the executor nor EXPLAIN currently need that data.
 		 */
 		appinfo->translated_vars = NIL;
+		appinfo->translated_fake_vars = NIL;
 
 		glob->appendRelations = lappend(glob->appendRelations, appinfo);
 	}
@@ -825,26 +826,21 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 				{
 					List	   *newRL = NIL;
 					ListCell   *lcrl,
-							   *lcrr,
-							   *lcp;
+							   *lcrr;
 
 					/*
-					 * Pass each per-subplan returningList through
+					 * Pass each per-resultrel returningList through
 					 * set_returning_clause_references().
 					 */
 					Assert(list_length(splan->returningLists) == list_length(splan->resultRelations));
-					Assert(list_length(splan->returningLists) == list_length(splan->plans));
-					forthree(lcrl, splan->returningLists,
-							 lcrr, splan->resultRelations,
-							 lcp, splan->plans)
+					forboth(lcrl, splan->returningLists, lcrr, splan->resultRelations)
 					{
 						List	   *rlist = (List *) lfirst(lcrl);
 						Index		resultrel = lfirst_int(lcrr);
-						Plan	   *subplan = (Plan *) lfirst(lcp);
 
 						rlist = set_returning_clause_references(root,
 																rlist,
-																subplan,
+																splan->subplan,
 																resultrel,
 																rtoffset);
 						newRL = lappend(newRL, rlist);
@@ -911,18 +907,15 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 					rc->prti += rtoffset;
 				}
 				/*
-				 * Caution: Do not change the relative ordering of this loop
-				 * and the statement below that adds the result relations to
-				 * root->glob->resultRelations, because we need to use the
+				 * Caution: Do not change the relative ordering of this and
+				 * the statement that follows that adds the result relations
+				 * to root->glob->resultRelations, because we need to use the
 				 * current value of list_length(root->glob->resultRelations)
 				 * in some plans.
 				 */
-				foreach(l, splan->plans)
-				{
-					lfirst(l) = set_plan_refs(root,
-											  (Plan *) lfirst(l),
-											  rtoffset);
-				}
+				splan->subplan = set_plan_refs(root,
+											   splan->subplan,
+											   rtoffset);
 
 				/*
 				 * Append this ModifyTable node's final result relation RT
@@ -2725,26 +2718,59 @@ set_update_tlist_references(PlannerInfo *root,
 							int rtoffset)
 {
 	ListCell   *lc1,
-			   *lc2,
-			   *lc3;
+			   *lc2;
 
-	forthree(lc1, splan->resultRelations,
-			 lc2, splan->updateTargetLists,
-			 lc3, splan->plans)
+	forboth(lc1, splan->resultRelations, lc2, splan->updateTargetLists)
 	{
 		Index	resultRelation = lfirst_int(lc1);
 		List   *update_tlist = lfirst(lc2);
-		Plan   *subplan = lfirst(lc3);
+		List   *targetlist;
 		indexed_tlist *itlist;
 
-		itlist = build_tlist_index(subplan->targetlist);
+		/*
+		 * root->processed_tlist in a non-inherited UPDATE or a child result
+		 * relation's version of it in an inherited UPDATE refers to the same
+		 * targetlist that splan->subplan produces.  update_tlist of a child
+		 * relation contains translated version of the expressions in the
+		 * splan->subplan's targetlist, so it is important that we use the
+		 * correct translated list.
+		 */
+		if (resultRelation == root->parse->resultRelation)
+		{
+			targetlist = root->processed_tlist;
+		}
+		else
+		{
+			ListCell   *lc;
+			AttrNumber	resno;
+			InheritResultRelInfo *resultInfo;
+
+			resultInfo = root->inherit_result_rel_array[resultRelation];
+			targetlist = resultInfo->processed_tlist;
+
+			/*
+			 * Make resnos of plan tlist TLEs match their ordinal position in
+			 * the list so that fix_join_expr() uses correct varattno for
+			 * OUTER Vars in update_tlist.  It's okay to scribble on these
+			 * entries now, because nobody should need to inspect them at
+			 * this point.
+			 */
+			resno = 1;
+			foreach(lc, targetlist)
+			{
+				TargetEntry *tle = lfirst(lc);
+
+				tle->resno = resno++;
+			}
+		}
+
+		itlist = build_tlist_index(targetlist);
 		lfirst(lc2) = fix_join_expr(root,
 									update_tlist,
 									itlist,
 									NULL,
 									resultRelation,
 									rtoffset);
-
 	}
 }
 
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 6eb7946..1ed5a07 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -2497,7 +2497,6 @@ finalize_plan(PlannerInfo *root, Plan *plan,
 		case T_ModifyTable:
 			{
 				ModifyTable *mtplan = (ModifyTable *) plan;
-				ListCell   *l;
 
 				/* Force descendant scan nodes to reference epqParam */
 				locally_added_param = mtplan->epqParam;
@@ -2512,16 +2511,13 @@ finalize_plan(PlannerInfo *root, Plan *plan,
 				finalize_primnode((Node *) mtplan->onConflictWhere,
 								  &context);
 				/* exclRelTlist contains only Vars, doesn't need examination */
-				foreach(l, mtplan->plans)
-				{
-					context.paramids =
-						bms_add_members(context.paramids,
-										finalize_plan(root,
-													  (Plan *) lfirst(l),
-													  gather_param,
-													  valid_params,
-													  scan_params));
-				}
+				context.paramids =
+					bms_add_members(context.paramids,
+									finalize_plan(root,
+												  mtplan->subplan,
+												  gather_param,
+												  valid_params,
+												  scan_params));
 			}
 			break;
 
diff --git a/src/backend/optimizer/prep/prepjointree.c b/src/backend/optimizer/prep/prepjointree.c
index 1452172..d24ac34 100644
--- a/src/backend/optimizer/prep/prepjointree.c
+++ b/src/backend/optimizer/prep/prepjointree.c
@@ -926,7 +926,6 @@ pull_up_simple_subquery(PlannerInfo *root, Node *jtnode, RangeTblEntry *rte,
 	subroot->grouping_map = NULL;
 	subroot->minmax_aggs = NIL;
 	subroot->qual_security_level = 0;
-	subroot->inhTargetKind = INHKIND_NONE;
 	subroot->hasRecursion = false;
 	subroot->wt_param_id = -1;
 	subroot->non_recursive_path = NULL;
diff --git a/src/backend/optimizer/prep/preptlist.c b/src/backend/optimizer/prep/preptlist.c
index 1ce5cc2..79c044a 100644
--- a/src/backend/optimizer/prep/preptlist.c
+++ b/src/backend/optimizer/prep/preptlist.c
@@ -57,7 +57,6 @@
 #include "rewrite/rewriteHandler.h"
 #include "utils/rel.h"
 
-static List *make_update_tlist(List *tlist, Index result_relation, Relation rel);
 static List *expand_targetlist(List *tlist, int command_type,
 							   Index result_relation, Relation rel);
 
@@ -108,6 +107,10 @@ preprocess_targetlist(PlannerInfo *root)
 	 * to identify the rows to be updated or deleted.  Note that this step
 	 * scribbles on parse->targetList, which is not very desirable, but we
 	 * keep it that way to avoid changing APIs used by FDWs.
+	 *
+	 * If target relation has inheritance children, junk column(s) needed
+	 * by the individual leaf child relations are added by
+	 * inherit.c: add_child_junk_attrs().
 	 */
 	if (command_type == CMD_UPDATE || command_type == CMD_DELETE)
 		rewriteTargetListUD(parse, target_rte, target_relation);
@@ -120,7 +123,9 @@ preprocess_targetlist(PlannerInfo *root)
 	 * For INSERT, we fix the the main targetlist itself to produce the full
 	 * tuple.  For UPDATE, we maintain another targetlist that is computed
 	 * separately from the main targetlist to get the full tuple, where any
-	 * missing values are taken from the old tuple.
+	 * missing values are taken from the old tuple.  If the UPDATE's target
+	 * relation has inheritance children, their update_tlist is maintained
+	 * separately; see inherit.c: add_inherit_result_relation_info().
 	 */
 	tlist = parse->targetList;
 	if (command_type == CMD_INSERT)
@@ -253,7 +258,6 @@ preprocess_targetlist(PlannerInfo *root)
 	return tlist;
 }
 
-
 /*
  * make_update_tlist
  * 		Wrapper over expand_targetlist for generating the expanded tlist
@@ -262,7 +266,7 @@ preprocess_targetlist(PlannerInfo *root)
  * The returned list does not contain any junk entries, only those for
  * target relation attributes.
  */
-static List *
+List *
 make_update_tlist(List *tlist, Index result_relation, Relation rel)
 {
 	return filter_junk_tlist_entries(expand_targetlist(tlist, CMD_UPDATE,
diff --git a/src/backend/optimizer/util/appendinfo.c b/src/backend/optimizer/util/appendinfo.c
index d722063..64c4ed1 100644
--- a/src/backend/optimizer/util/appendinfo.c
+++ b/src/backend/optimizer/util/appendinfo.c
@@ -29,6 +29,7 @@ typedef struct
 	PlannerInfo *root;
 	int			nappinfos;
 	AppendRelInfo **appinfos;
+	bool		need_parent_wholerow;
 } adjust_appendrel_attrs_context;
 
 static void make_inh_translation_list(Relation oldrelation,
@@ -37,8 +38,6 @@ static void make_inh_translation_list(Relation oldrelation,
 									  AppendRelInfo *appinfo);
 static Node *adjust_appendrel_attrs_mutator(Node *node,
 											adjust_appendrel_attrs_context *context);
-static List *adjust_inherited_tlist(List *tlist,
-									AppendRelInfo *context);
 
 
 /*
@@ -200,42 +199,42 @@ adjust_appendrel_attrs(PlannerInfo *root, Node *node, int nappinfos,
 	context.root = root;
 	context.nappinfos = nappinfos;
 	context.appinfos = appinfos;
+	context.need_parent_wholerow = true;
 
 	/* If there's nothing to adjust, don't call this function. */
 	Assert(nappinfos >= 1 && appinfos != NULL);
 
-	/*
-	 * Must be prepared to start with a Query or a bare expression tree.
-	 */
-	if (node && IsA(node, Query))
-	{
-		Query	   *newnode;
-		int			cnt;
+	/* Should never be translating a Query tree. */
+	Assert (node == NULL || !IsA(node, Query));
+	result = adjust_appendrel_attrs_mutator(node, &context);
 
-		newnode = query_tree_mutator((Query *) node,
-									 adjust_appendrel_attrs_mutator,
-									 (void *) &context,
-									 QTW_IGNORE_RC_SUBQUERIES);
-		for (cnt = 0; cnt < nappinfos; cnt++)
-		{
-			AppendRelInfo *appinfo = appinfos[cnt];
+	return result;
+}
 
-			if (newnode->resultRelation == appinfo->parent_relid)
-			{
-				newnode->resultRelation = appinfo->child_relid;
-				/* Fix tlist resnos too, if it's inherited UPDATE */
-				if (newnode->commandType == CMD_UPDATE)
-					newnode->targetList =
-						adjust_inherited_tlist(newnode->targetList,
-											   appinfo);
-				break;
-			}
-		}
+/*
+ * adjust_target_appendrel_attrs
+ *		like adjust_appendrel_attrs, but treats wholerow Vars a bit
+ *		differently in that it doesn't convert any child table
+ *		wholerows contained in 'node' back to the parent reltype.
+ */
+Node *
+adjust_target_appendrel_attrs(PlannerInfo *root, Node *node,
+							  AppendRelInfo *appinfo)
+{
+	Node	   *result;
+	adjust_appendrel_attrs_context context;
 
-		result = (Node *) newnode;
-	}
-	else
-		result = adjust_appendrel_attrs_mutator(node, &context);
+	context.root = root;
+	context.nappinfos = 1;
+	context.appinfos = &appinfo;
+	context.need_parent_wholerow = false;
+
+	/* If there's nothing to adjust, don't call this function. */
+	Assert(appinfo != NULL);
+
+	/* Should never be translating a Query tree. */
+	Assert (node == NULL || !IsA(node, Query));
+	result = adjust_appendrel_attrs_mutator(node, &context);
 
 	return result;
 }
@@ -277,11 +276,16 @@ adjust_appendrel_attrs_mutator(Node *node,
 			{
 				Node	   *newnode;
 
+				/*
+				 * If this Var appears to have a unusual attno assigned, it
+				 * must be one of the "fake" vars added to a parent target
+				 * relation's reltarget; see add_inherit_junk_var().
+				 */
 				if (var->varattno > list_length(appinfo->translated_vars))
-					elog(ERROR, "attribute %d of relation \"%s\" does not exist",
-						 var->varattno, get_rel_name(appinfo->parent_reloid));
-				newnode = copyObject(list_nth(appinfo->translated_vars,
-											  var->varattno - 1));
+					newnode = translate_fake_parent_var(var, appinfo);
+				else
+					newnode = copyObject(list_nth(appinfo->translated_vars,
+												  var->varattno - 1));
 				if (newnode == NULL)
 					elog(ERROR, "attribute %d of relation \"%s\" does not exist",
 						 var->varattno, get_rel_name(appinfo->parent_reloid));
@@ -298,7 +302,10 @@ adjust_appendrel_attrs_mutator(Node *node,
 				if (OidIsValid(appinfo->child_reltype))
 				{
 					Assert(var->vartype == appinfo->parent_reltype);
-					if (appinfo->parent_reltype != appinfo->child_reltype)
+					/* Make sure the Var node has the right type ID, too */
+					var->vartype = appinfo->child_reltype;
+					if (appinfo->parent_reltype != appinfo->child_reltype &&
+						context->need_parent_wholerow)
 					{
 						ConvertRowtypeExpr *r = makeNode(ConvertRowtypeExpr);
 
@@ -306,8 +313,6 @@ adjust_appendrel_attrs_mutator(Node *node,
 						r->resulttype = appinfo->parent_reltype;
 						r->convertformat = COERCE_IMPLICIT_CAST;
 						r->location = -1;
-						/* Make sure the Var node has the right type ID, too */
-						var->vartype = appinfo->child_reltype;
 						return (Node *) r;
 					}
 				}
@@ -361,44 +366,6 @@ adjust_appendrel_attrs_mutator(Node *node,
 		}
 		return (Node *) cexpr;
 	}
-	if (IsA(node, RangeTblRef))
-	{
-		RangeTblRef *rtr = (RangeTblRef *) copyObject(node);
-
-		for (cnt = 0; cnt < nappinfos; cnt++)
-		{
-			AppendRelInfo *appinfo = appinfos[cnt];
-
-			if (rtr->rtindex == appinfo->parent_relid)
-			{
-				rtr->rtindex = appinfo->child_relid;
-				break;
-			}
-		}
-		return (Node *) rtr;
-	}
-	if (IsA(node, JoinExpr))
-	{
-		/* Copy the JoinExpr node with correct mutation of subnodes */
-		JoinExpr   *j;
-		AppendRelInfo *appinfo;
-
-		j = (JoinExpr *) expression_tree_mutator(node,
-												 adjust_appendrel_attrs_mutator,
-												 (void *) context);
-		/* now fix JoinExpr's rtindex (probably never happens) */
-		for (cnt = 0; cnt < nappinfos; cnt++)
-		{
-			appinfo = appinfos[cnt];
-
-			if (j->rtindex == appinfo->parent_relid)
-			{
-				j->rtindex = appinfo->child_relid;
-				break;
-			}
-		}
-		return (Node *) j;
-	}
 	if (IsA(node, PlaceHolderVar))
 	{
 		/* Copy the PlaceHolderVar node with correct mutation of subnodes */
@@ -487,6 +454,10 @@ adjust_appendrel_attrs_mutator(Node *node,
 	Assert(!IsA(node, SubLink));
 	Assert(!IsA(node, Query));
 
+	/* We should never see these Query substructures. */
+	Assert(!IsA(node, RangeTblRef));
+	Assert(!IsA(node, JoinExpr));
+
 	return expression_tree_mutator(node, adjust_appendrel_attrs_mutator,
 								   (void *) context);
 }
@@ -621,103 +592,6 @@ adjust_child_relids_multilevel(PlannerInfo *root, Relids relids,
 }
 
 /*
- * Adjust the targetlist entries of an inherited UPDATE operation
- *
- * The expressions have already been fixed, but we have to make sure that
- * the target resnos match the child table (they may not, in the case of
- * a column that was added after-the-fact by ALTER TABLE).  In some cases
- * this can force us to re-order the tlist to preserve resno ordering.
- * (We do all this work in special cases so that preptlist.c is fast for
- * the typical case.)
- *
- * The given tlist has already been through expression_tree_mutator;
- * therefore the TargetEntry nodes are fresh copies that it's okay to
- * scribble on.
- *
- * Note that this is not needed for INSERT because INSERT isn't inheritable.
- */
-static List *
-adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
-{
-	bool		changed_it = false;
-	ListCell   *tl;
-	List	   *new_tlist;
-	bool		more;
-	int			attrno;
-
-	/* This should only happen for an inheritance case, not UNION ALL */
-	Assert(OidIsValid(context->parent_reloid));
-
-	/* Scan tlist and update resnos to match attnums of child rel */
-	foreach(tl, tlist)
-	{
-		TargetEntry *tle = (TargetEntry *) lfirst(tl);
-		Var		   *childvar;
-
-		if (tle->resjunk)
-			continue;			/* ignore junk items */
-
-		/* Look up the translation of this column: it must be a Var */
-		if (tle->resno <= 0 ||
-			tle->resno > list_length(context->translated_vars))
-			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
-				 tle->resno, get_rel_name(context->parent_reloid));
-		childvar = (Var *) list_nth(context->translated_vars, tle->resno - 1);
-		if (childvar == NULL || !IsA(childvar, Var))
-			elog(ERROR, "attribute %d of relation \"%s\" does not exist",
-				 tle->resno, get_rel_name(context->parent_reloid));
-
-		if (tle->resno != childvar->varattno)
-		{
-			tle->resno = childvar->varattno;
-			changed_it = true;
-		}
-	}
-
-	/*
-	 * If we changed anything, re-sort the tlist by resno, and make sure
-	 * resjunk entries have resnos above the last real resno.  The sort
-	 * algorithm is a bit stupid, but for such a seldom-taken path, small is
-	 * probably better than fast.
-	 */
-	if (!changed_it)
-		return tlist;
-
-	new_tlist = NIL;
-	more = true;
-	for (attrno = 1; more; attrno++)
-	{
-		more = false;
-		foreach(tl, tlist)
-		{
-			TargetEntry *tle = (TargetEntry *) lfirst(tl);
-
-			if (tle->resjunk)
-				continue;		/* ignore junk items */
-
-			if (tle->resno == attrno)
-				new_tlist = lappend(new_tlist, tle);
-			else if (tle->resno > attrno)
-				more = true;
-		}
-	}
-
-	foreach(tl, tlist)
-	{
-		TargetEntry *tle = (TargetEntry *) lfirst(tl);
-
-		if (!tle->resjunk)
-			continue;			/* here, ignore non-junk items */
-
-		tle->resno = attrno;
-		new_tlist = lappend(new_tlist, tle);
-		attrno++;
-	}
-
-	return new_tlist;
-}
-
-/*
  * find_appinfos_by_relids
  * 		Find AppendRelInfo structures for all relations specified by relids.
  *
